<template>
    <header class="l-header l-header_no-image l-header_theme-color-2">
        <div class="l-header__shapes" aria-hidden="true" :style="transformStyle">
            <div class="l-header__shape"></div>
        </div>

        <div class="container mx-auto l-header__content px-5 z-0">
            <div>
                <h1 class="l-header__title">
                    <p>
                        <slot name="title" />
                    </p>
                </h1>

                <div class="l-header__subtitle lg:w-2/3 md:w-2/3">
                    <p>
                        <slot name="subtitle" />
                    </p>
                </div>

                <slot name="cta" />

                <nav aria-label="Breadcrumb" v-if="breadcrumbs.length !== 0">
                    <ol role="list" class="flex items-center space-x-1 text-sm text-blue-50">
                        <li>
                            <a class="block transition-colors hover:text-gray-700" href="/">
                                <span class="sr-only">Home</span>

                                <svg xmlns="http://www.w3.org/2000/svg" class="w-4 h-4" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                                    <path
                                        stroke-linecap="round"
                                        stroke-linejoin="round"
                                        stroke-width="2"
                                        d="M3 12l2-2m0 0l7-7 7 7M5 10v10a1 1 0 001 1h3m10-11l2 2m-2-2v10a1 1 0 01-1 1h-3m-6 0a1 1 0 001-1v-4a1 1 0 011-1h2a1 1 0 011 1v4a1 1 0 001 1m-6 0h6"
                                    />
                                </svg>
                            </a>
                        </li>

                        <template v-for="breadcrumb in breadcrumbs">
                            <li>
                                <svg xmlns="http://www.w3.org/2000/svg" class="w-4 h-4" viewBox="0 0 20 20" fill="currentColor">
                                    <path
                                        fill-rule="evenodd"
                                        d="M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z"
                                        clip-rule="evenodd"
                                    />
                                </svg>
                            </li>

                            <li>
                                <a class="block transition-colors hover:text-gray-700" :href="breadcrumb.url">
                                    {{ breadcrumb.label }}
                                </a>
                            </li>
                        </template>
                        <li>
                            <svg xmlns="http://www.w3.org/2000/svg" class="w-4 h-4" viewBox="0 0 20 20" fill="currentColor">
                                <path
                                    fill-rule="evenodd"
                                    d="M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z"
                                    clip-rule="evenodd"
                                />
                            </svg>
                        </li>
                        <li>
                            <slot name="title" />
                        </li>
                    </ol>
                </nav>
            </div>
        </div>
    </header>
</template>

<script>
    import throttle from 'lodash.throttle';

    export default {
        props: {
            breadcrumbs: {
                type: Array,
                default: () => [],
            },
        },
        data() {
            return {
                hasSlot: false,
                // 60 fps = frames of 16 ms
                windowScrollListener: throttle(this.onWindowScroll, 16),
                scrollY: 0,
            };
        },
        computed: {
            transformStyle() {
                return {
                    '--translate': `${this.scrollY}px`,
                    // Rotation degrees are initiated as specified in @maltjoy/layout
                    '--rotate1': `-${38 + this.scrollY / 10}deg`,
                    '--rotate2': `-${22 + this.scrollY / 20}deg`,
                    '--rotate3': `-${12 + this.scrollY / 40}deg`,
                };
            },
        },
        methods: {
            onWindowScroll() {
                this.scrollY = window.scrollY;
            },
        },
        mounted() {
            console.log(
                '      ___          ___                            \n' +
                    '     /__/\\        /  /\\                     ___   \n' +
                    '    |  |::\\      /  /::\\                   /  /\\  \n' +
                    '    |  |:|:\\    /  /:/\\:\\   ___     ___   /  /:/  \n' +
                    '  __|__|:|\\:\\  /  /:/~/::\\ /__/\\   /  /\\ /  /:/   \n' +
                    ' /__/::::| \\:\\/__/:/ /:/\\:\\\\  \\:\\ /  /://  /::\\   \n' +
                    ' \\  \\:\\~~\\__\\/\\  \\:\\/:/__\\/ \\  \\:\\  /://__/:/\\:\\  \n' +
                    '  \\  \\:\\       \\  \\::/       \\  \\:\\/:/ \\__\\/  \\:\\ \n' +
                    '   \\  \\:\\       \\  \\:\\        \\  \\::/       \\  \\:\\\n' +
                    '    \\  \\:\\       \\  \\:\\        \\__\\/         \\__\\/\n' +
                    '     \\__\\/        \\__\\/                           \n\n' +
                    'Want to really know how it works under the hood? Come join us in the team, we are recruiting :) \n\n' +
                    '-> https://careers.malt.com <-',
            );

            // Do not animate shapes when user has requested to minimize the amount of non-essential motions
            const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
            if (!mediaQuery.matches) {
                window.addEventListener('scroll', this.windowScrollListener);
            }
        },
        beforeDestroy() {
            window.removeEventListener('scroll', this.windowScrollListener);
        },
    };
</script>

<style lang="scss" scoped>
    .l-header {
        &__shapes {
            --translate: 0px;
            --rotate1: -38deg;
            --rotate2: -22deg;
            --rotate3: -12deg;

            $transition: transform 200ms ease-in-out;

            &::before {
                transform: translate(var(--translate)) rotate(var(--rotate1));
                transition: $transition;
            }

            .l-header__shape::before {
                transform: translate(var(--translate)) rotate(var(--rotate2));
                transition: $transition;
            }

            &::after {
                transform: translate(var(--translate)) rotate(var(--rotate3));
                transition: $transition;
            }
        }
    }
</style>
